DEFINE CLASS tabStretch AS page
    Caption = "Stretch"
    Name    = "tabStretch"
    ADD OBJECT Panel1 AS cntStretch 
ENDDEFINE

DEFINE CLASS tabFieldClass AS page
    Caption = "Field class"
    Name    = "tabFieldClass"
    ADD OBJECT Panel1 AS cntFieldClass
ENDDEFINE

DEFINE CLASS cntFieldClass as Container
    BorderWidth = 0
    BackStyle = 0
    Width = 300
    Height = 300

	ADD OBJECT chkApply as checkbox WITH ;
		left = 10, top = 15, value = .f., caption = "Apply on save", backStyle = 0

	ADD OBJECT lblClass as Label WITH ;
		left = 10, top = 50, Caption = "Fields class expression:", backStyle = 0, autosize = .t.

	ADD OBJECT txtClass as textbox WITH ;
		left = 160, top = 47, value = ""

	PROCEDURE LoadFromFRX()
		this.chkApply.value = .f.
	ENDPROC
	
	PROCEDURE SaveToFRX()
	LOCAL loFRX
	loFRX = NEWOBJECT("frxCursor", "_frxcursor.vcx", _reportoutput)
	SELECT frx	
	SCAN ALL FOR curpos
		IF loFRX.UnpackMemberData()
			SELECT memberdata
			LOCATE ALL FOR name = "Microsoft.VFP.Reporting.Builder.AdvancedProperty" AND execwhen="Field.Class" AND type="R"
			IF !FOUND()
				APPEND BLANK
				replace name WITH "Microsoft.VFP.Reporting.Builder.AdvancedProperty", ;
					execwhen WITH "Field.Class", type WITH "R"
			endif
			replace execute WITH ALLTRIM(this.txtClass.value)
			loFRX.PackUpMemberData()
		endif		
	ENDSCAN
	ENDPROC		

ENDDEFINE

DEFINE CLASS cntStretch as Container
    BorderWidth = 0
    BackStyle = 0
    Width = 300
    Height = 300

	ADD OBJECT XStretch as spinner WITH ;
		left = 160, top = 27, value = 100

	ADD OBJECT YStretch as spinner WITH ;
		left = 160, top = 52, value = 100

	ADD OBJECT XStretchLabel as Label WITH ;
		left = 10, top = 30, Caption = "Horizontal stretch factor (%):", backStyle = 0, autosize = .t.

	ADD OBJECT YStretchLabel as Label WITH ;
		left = 10, top = 55, Caption = "Vertical stretch factor (%):", backStyle = 0, autosize = .t.

    PROCEDURE LoadFromFrx()
        SELECT memberdata
    	LOCATE ALL FOR name="Prague.DevCon.2007.Stretch"
    	IF FOUND()
    		this.XStretch.value = VAL(xStretch)
    		this.YStretch.value = VAL(yStretch)
    	endif
    ENDPROC

    PROCEDURE SaveToFrx()
    	SELECT memberdata
    	IF EMPTY(FIELD("xStretch"))
    		ALTER table memberdata ADD COLUMN xStretch M
    	ENDIF
    	IF EMPTY(FIELD("yStretch"))
    		ALTER table memberdata ADD COLUMN yStretch M
    	ENDIF
    	LOCATE ALL FOR name="Prague.DevCon.2007.Stretch"
    	IF NOT FOUND()
    		APPEND BLANK
    		replace name WITH "Prague.DevCon.2007.Stretch"    		
    	ENDIF
    	replace xStretch WITH ALLTRIM(STR(this.XStretch.value))
    	replace yStretch WITH ALLTRIM(STR(this.YStretch.value))
    ENDPROC
ENDDEFINE