SET REPORTBEHAVIOR 90

SELECT SUM(amount) amount, YEAR(date) year, ;
	SUM(IIF(MONTH(date)=1,amount,0)) january, ;
	SUM(IIF(MONTH(date)=2,amount,0)) february, ;
	SUM(IIF(MONTH(date)=3,amount,0)) march, ;
	SUM(IIF(MONTH(date)=4,amount,0)) april, ;
	SUM(IIF(MONTH(date)=5,amount,0)) may, ;
	SUM(IIF(MONTH(date)=6,amount,0)) june, ;
	SUM(IIF(MONTH(date)=7,amount,0)) july, ;
	SUM(IIF(MONTH(date)=8,amount,0)) august, ;
	SUM(IIF(MONTH(date)=9,amount,0)) september, ;
	SUM(IIF(MONTH(date)=10,amount,0)) october, ;
	SUM(IIF(MONTH(date)=11,amount,0)) november, ;
	SUM(IIF(MONTH(date)=12,amount,0)) december, ;
	areas.name area, MAX(areas.id) areaid ;
	FROM sales JOIN areas ON sales.area = areas.id ;
	GROUP BY areas.name, 2 ORDER BY 2 ;
	having (year) in (2005,2006) ;
	INTO CURSOR salesByMonth

&& example 1
MODIFY REPORT sales1 nowait

&& example 2
&&MODIFY REPORT sales2 nowait

&& example 3
&&MODIFY REPORT sales3 nowait

&& example 4
&&MODIFY REPORT sales4 nowait

RETURN 

&& example 5
LOCAL loListener
DO (_reportoutput) WITH 1, loListener
loListener.addCollectionMember("fxMonthlySales", "", "sales.prg", .T., .F.)
*REPORT FORM sales5 OBJECT loListener
MODIFY REPORT sales5 nowait

PROCEDURE HighNumber
LPARAMETERS tnArea, tnValue
DO case
	CASE INLIST(tnArea, 1,3)
		RETURN tnValue > 250000
	OTHERWISE
		RETURN tnValue > 50000
ENDCASE

PROCEDURE LowNumber
LPARAMETERS tnArea, tnValue
DO case
	CASE INLIST(tnArea, 1,3)
		RETURN tnValue < 50000
	OTHERWISE
		RETURN tnValue < 7000
ENDCASE

PROCEDURE ApplyDynamicNumberStyle
LPARAMETERS tnArea, tnValue, oProps
m.oProps.Reload = .t.

DO case
	CASE LowNumber(tnArea, tnValue)
      m.oProps.FillRed = 255
      m.oProps.FillGreen = 102
      m.oProps.FillBlue = 102

*	CASE HighNumber(tnArea, tnValue)
*      m.oProps.FontStyle = 5

	CASE HighNumber(tnArea, tnValue)
      m.oProps.FillRed = 121
      m.oProps.FillGreen = 188
      m.oProps.FillBlue = 255

   OTHERWISE  && default result from FRX definition
      m.oProps.Reload = .F.   
endcase

DEFINE CLASS MonthlySales as Custom
	PROCEDURE Decorate
	LPARAMETERS oProps
		ApplyDynamicNumberStyle(areaID, oProps.value, oProps)
	ENDPROC
ENDDEFINE

DEFINE CLASS Holidays as Custom
	PROCEDURE Decorate
	LPARAMETERS oProps
		oProps.Reload = .t.
		oProps.FontStyle = 5
	ENDPROC
ENDDEFINE


DEFINE CLASS fxMonthlySales as Custom
	Procedure ApplyFX
	LPARAMETER toListener, tcMethodToken, tp1, tp2, tp3, tp4, tp5, tp6, tp7, tp8, tp9, tp10, tp11, tp12
	IF tcMethodToken=="BEFOREREPORT"
		toListener.CallEvaluateContents = 0 && make the engine invoke the EvaluateContents event
	endif
	IF tcMethodToken!="EVALUATECONTENTS"
		RETURN
	ENDIF
	SET DATASESSION TO (toListener.FRXDataSession)
	SELECT (toListener.MemberDataAlias)
	LOCAL lnRecno
	lnRecno = toListener.getFRXRecno(tcMethodToken,tP1, tP2)
	LOCATE ALL FOR frxRecno = lnRecno AND name = "Microsoft.VFP.Reporting.Builder.AdvancedProperty" AND execwhen="Field.Class"
	IF FOUND()
		LOCAL loDecorator, lcExecute
		lcExecute = eval(execute)
		SET DATASESSION TO (toListener.CurrentDataSession)
		loDecorator = CREATEOBJECT(lcExecute)
		loDecorator.Decorate(tp2)
	ELSE
		SET DATASESSION TO (toListener.CurrentDataSession)
	endif
ENDDEFINE


